import { Context } from './core';
import { MediaDef } from './util/media';
import { RhoProcessor } from './processor';
export interface ContextWithMedia extends Context {
    mediaIds: Set<string>;
    resolvedMedia: Map<string, MediaDef>;
    isExternalLink(media: MediaDef): boolean;
    isLazy(media: MediaDef): boolean;
    getNextInlineId(): string;
}
export declare class RhoContext extends Context implements ContextWithMedia {
    readonly processor: RhoProcessor;
    constructor(processor: RhoProcessor);
    linkCounter: number;
    mediaIds: Set<string>;
    resolvedMedia: Map<string, MediaDef>;
    isExternalLink(media: MediaDef): boolean;
    isLazy(media: MediaDef): boolean;
    getNextInlineId(): string;
}
