import { Region } from './region';
export declare class Cursor {
    protected _pos: number;
    readonly region: Region;
    constructor(source: string | Region, _pos?: number);
    get pos(): number;
    set(i: number): this;
    clone(): Cursor;
    peek(offset?: number): string;
    peekCode(offset?: number): number;
    current(): string;
    currentCode(): number;
    hasCurrent(): boolean;
    subRegion(start: number, end?: number): Region;
    at(str: string): boolean;
    atCode(code: number, offset?: number): boolean;
    atSeq(...seq: number[]): boolean;
    atInsensitive(str: string): boolean;
    atDigit(): boolean;
    atLatin(): boolean;
    atIdentifier(): boolean;
    atNewLine(): boolean;
    atBlankLine(): boolean;
    atSpace(): boolean;
    atSpaces(count: number): boolean;
    atWhitespace(): boolean;
    atTaint(): boolean;
    skipTainted(): this;
    skip(n?: number): this;
    skipString(str: string): this;
    skipSpaces(count?: number): this;
    skipNewLine(): this;
    skipNewLines(): this;
    skipWhitespaces(): this;
    skipBlankLines(): this;
    skipToEol(): this;
    skipToEndOfBlock(): this;
    readUntil(newPos: number): Region;
    readForward(relNewPos: number): Region;
    readLine(): Region;
    scan(...seq: number[]): number | null;
    scanLine(...seq: number[]): number | null;
    debug(): string;
}
