"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Node = (function () {
    function Node(region, children) {
        if (children === void 0) { children = []; }
        this.region = region;
        this.children = children;
    }
    Node.prototype.render = function (ctx) {
        return ctx.renderChildren(this);
    };
    Node.prototype.debug = function (indent) {
        if (indent === void 0) { indent = ''; }
        var lines = indent + '\u001b[33m' + this.constructor.name + '\u001b[0m ' +
            '\u001b[46m\u001b[30m' + this.region.toString() + '\u001b[0m';
        for (var _i = 0, _a = this.children; _i < _a.length; _i++) {
            var child = _a[_i];
            lines += "\n" + child.debug(indent + '  ');
        }
        return lines;
    };
    return Node;
}());
exports.Node = Node;
//# sourceMappingURL=node.js.map