import { Rule } from './rule';
import { Context } from './context';
import { Node } from './node';
export declare type ParserDef = (ctx: Context) => Rule[];
export declare type NodeTransform = (node: Node, ctx: Context) => Node[];
export declare class Processor {
    protected mainParserId: string;
    protected parserDefs: Map<string, ParserDef>;
    transforms: NodeTransform[];
    options: object;
    constructor(options?: object);
    toHtml(str: string): string;
    createContext(): Context;
    setMainParser(parserId: string): this;
    defineParser(parserId: string, def: ParserDef): this;
    getParserDef(parserId: string): ParserDef;
    getMainParserDef(): ParserDef;
    transform(fn: NodeTransform): this;
}
