"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var exception_1 = require("./exception");
var Rule = (function () {
    function Rule(ctx) {
        this.ctx = ctx;
    }
    Rule.prototype.parse = function (cursor) {
        var pos = cursor.pos;
        var node = this.parseAt(cursor);
        if (node == null) {
            cursor.set(pos);
        }
        else if (cursor.pos <= pos) {
            throw new exception_1.Exception({
                code: 'InvalidRule',
                message: 'Parse rule must advance cursor position if it emits a node',
                details: {
                    rule: this,
                    cursor: cursor,
                }
            });
        }
        return node;
    };
    return Rule;
}());
exports.Rule = Rule;
var DelegateRule = (function (_super) {
    __extends(DelegateRule, _super);
    function DelegateRule(ctx, parserId) {
        var _this = _super.call(this, ctx) || this;
        _this.parserId = parserId;
        return _this;
    }
    DelegateRule.prototype.parseAt = function (cursor) {
        var parser = this.ctx.getParser(this.parserId);
        return parser.parseSinglePass(cursor);
    };
    return DelegateRule;
}(Rule));
exports.DelegateRule = DelegateRule;
//# sourceMappingURL=rule.js.map