"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("./core");
var rules_1 = require("./rules");
var options_1 = require("./options");
var context_1 = require("./context");
var CHAR_AMP = core_1.constants.CHAR_AMP, CHAR_LT = core_1.constants.CHAR_LT, CHAR_GT = core_1.constants.CHAR_GT, CHAR_BACKSLASH = core_1.constants.CHAR_BACKSLASH, CHAR_BACKTICK = core_1.constants.CHAR_BACKTICK;
var RhoProcessor = (function (_super) {
    __extends(RhoProcessor, _super);
    function RhoProcessor(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this) || this;
        _this.options = __assign(__assign({}, options_1.RHO_DEFAULT_OPTIONS), options);
        _this.setMainParser('block');
        _this.defineParser('block', function (ctx) { return [
            new rules_1.HeadingRule(ctx, { minLevel: 1, maxLevel: 6 }),
            new core_1.DelegateRule(ctx, 'list'),
            new rules_1.CodeBlockRule(ctx),
            new rules_1.DivBlockRule(ctx),
            new rules_1.IndentedBlock(ctx),
            new rules_1.HtmlBlockRule(ctx),
            new rules_1.HrRule(ctx),
            new rules_1.ParagraphRule(ctx),
        ]; });
        _this.defineParser('list', function (ctx) { return [
            new rules_1.ListRule(ctx, { tagName: 'ul', marker: '* ' }),
            new rules_1.ListRule(ctx, { tagName: 'ul', marker: '- ' }),
            new rules_1.ListRule(ctx, { tagName: 'ol', marker: '#. ' }),
            new rules_1.NumberedListRule(ctx, { tagName: 'ol', marker: '1. ' }),
        ]; });
        _this.defineParser('inline', function (ctx) { return [
            new rules_1.PlainTextRule(ctx),
            new rules_1.TypographicsRule(ctx, _this.options),
            new rules_1.BackslashEscapeRule(ctx),
            new rules_1.HtmlTagRule(ctx),
            new rules_1.HtmlCommentRule(ctx),
            new rules_1.HtmlEntityRule(ctx),
            new rules_1.EmRule(ctx),
            new rules_1.StrongRule(ctx),
            new rules_1.StrikeRule(ctx),
            new rules_1.CodeSpanRule(ctx),
            new rules_1.FormulaRule(ctx, { marker: '$$' }),
            new rules_1.FormulaRule(ctx, { marker: '%%' }),
            new rules_1.LinkRule(ctx),
            new rules_1.HeadlessLinkRule(ctx),
            new rules_1.MediaRule(ctx),
            new rules_1.HeadlessMediaRule(ctx),
            new rules_1.VerbatimRule(ctx),
        ]; });
        _this.defineParser('code', function (ctx) { return [
            new rules_1.PlainTextRule(ctx, {
                controlCharacters: [
                    CHAR_BACKTICK,
                    CHAR_AMP,
                    CHAR_LT,
                    CHAR_GT,
                    CHAR_BACKSLASH,
                ]
            }),
            new rules_1.BackslashEscapeRule(ctx, {
                controlCharacters: [CHAR_BACKTICK]
            }),
            new rules_1.HtmlEntityRule(ctx),
            new rules_1.VerbatimRule(ctx),
        ]; });
        return _this;
    }
    RhoProcessor.prototype.createContext = function () {
        return new context_1.RhoContext(this);
    };
    return RhoProcessor;
}(core_1.Processor));
exports.RhoProcessor = RhoProcessor;
//# sourceMappingURL=processor.js.map