import { Rule, Region, Node, Cursor } from '../../core';
import { Selector } from '../../util/selector';
export declare abstract class BlockRule extends Rule {
    lineStartPos: number;
    indent: number;
    selector: Selector | null;
    protected abstract parseSubRegion(region: Region): Node | null;
    protected abstract scanBlock(cursor: Cursor): Region | null;
    protected allowsMultipleSelectors(): boolean;
    protected parseAt(cursor: Cursor): Node | null;
    countBlockIndent(cursor: Cursor): void;
    parseInlineContent(region: Region): Node[];
    parseBlockContent(region: Region): Node[];
    captureSelector(region: Region, allowMultiple?: boolean): Selector | null;
    protected parseSelectorAt(cursor: Cursor, allowMultiple?: boolean): Selector | null;
    protected parseSelectorComponent(marker: number, cursor: Cursor): string | null;
}
