"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../../core");
var CHAR_BACKSLASH = core_1.constants.CHAR_BACKSLASH;
var BracketRule = (function (_super) {
    __extends(BracketRule, _super);
    function BracketRule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BracketRule.prototype.parseAt = function (cursor) {
        var _a = this, openMarker = _a.openMarker, closeMarker = _a.closeMarker;
        if (!cursor.at(openMarker)) {
            return null;
        }
        cursor.skip(openMarker.length);
        var start = cursor.pos;
        while (cursor.hasCurrent()) {
            if (cursor.atCode(CHAR_BACKSLASH)) {
                cursor.skip(2);
                continue;
            }
            if (cursor.at(closeMarker)) {
                var region = cursor.subRegion(start, cursor.pos);
                cursor.skip(closeMarker.length);
                return this.parseSubRegion(region);
            }
            cursor.skip();
        }
        return null;
    };
    return BracketRule;
}(core_1.Rule));
exports.BracketRule = BracketRule;
//# sourceMappingURL=bracket.js.map