"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../../core");
var nodes_1 = require("../../nodes");
var fenced_block_1 = require("./fenced-block");
var CodeBlockRule = (function (_super) {
    __extends(CodeBlockRule, _super);
    function CodeBlockRule() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.contentStart = 0;
        _this.contentEnd = 0;
        return _this;
    }
    Object.defineProperty(CodeBlockRule.prototype, "marker", {
        get: function () {
            return '```';
        },
        enumerable: true,
        configurable: true
    });
    CodeBlockRule.prototype.parseContent = function (region) {
        var codeParser = this.ctx.getParser('code');
        var cursor = new core_1.Cursor(region);
        var lines = [];
        while (cursor.hasCurrent()) {
            cursor.skipSpaces(this.indent);
            var start = cursor.pos;
            cursor.skipToEol().skipNewLine();
            var line = cursor.subRegion(start, cursor.pos);
            var ast = codeParser.parse(line);
            lines.push(ast);
        }
        var code = new nodes_1.HtmlElementNode(region, lines, 'code', null, true);
        var pre = new nodes_1.HtmlElementNode(region, [code], 'pre', this.selector);
        return pre;
    };
    return CodeBlockRule;
}(fenced_block_1.FencedBlockRule));
exports.CodeBlockRule = CodeBlockRule;
//# sourceMappingURL=code-block.js.map