"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var block_1 = require("./block");
var FencedBlockRule = (function (_super) {
    __extends(FencedBlockRule, _super);
    function FencedBlockRule() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.contentStart = -1;
        _this.contentEnd = -1;
        return _this;
    }
    FencedBlockRule.prototype.scanBlock = function (cursor) {
        var marker = this.marker;
        if (!cursor.at(marker)) {
            return null;
        }
        var blockStart = cursor.pos;
        cursor.skip(marker.length).skipToEol().skipNewLine();
        this.contentStart = cursor.region.start + cursor.pos;
        this.contentEnd = -1;
        while (cursor.hasCurrent()) {
            cursor.skipSpaces(this.indent);
            if (!cursor.at(marker)) {
                cursor.skipToEol().skipNewLine();
                continue;
            }
            var contentEnd = cursor.region.start + cursor.pos;
            cursor.skip(marker.length).skipSpaces();
            if (cursor.atBlankLine()) {
                cursor.skipNewLine();
                if (cursor.atBlankLine()) {
                    this.contentEnd = contentEnd;
                    break;
                }
            }
        }
        if (this.contentEnd === -1) {
            return null;
        }
        cursor.skipBlankLines();
        return cursor.subRegion(blockStart, cursor.pos);
    };
    FencedBlockRule.prototype.parseSubRegion = function (region) {
        var offset = this.contentStart - region.start;
        var length = this.contentEnd - this.contentStart;
        var contentRegion = region.subRegion(offset, offset + length);
        return this.parseContent(contentRegion);
    };
    return FencedBlockRule;
}(block_1.BlockRule));
exports.FencedBlockRule = FencedBlockRule;
//# sourceMappingURL=fenced-block.js.map