"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var block_1 = require("./block");
var nodes_1 = require("../../nodes");
var HeadingRule = (function (_super) {
    __extends(HeadingRule, _super);
    function HeadingRule(ctx, options) {
        var _a;
        var _this = _super.call(this, ctx) || this;
        _this.level = 0;
        _this.marker = (_a = options.marker, (_a !== null && _a !== void 0 ? _a : '#'));
        _this.minLevel = options.minLevel;
        _this.maxLevel = options.maxLevel;
        return _this;
    }
    HeadingRule.prototype.scanBlock = function (cursor) {
        this.level = 0;
        while (cursor.at(this.marker)) {
            cursor.skip(this.marker.length);
            this.level += 1;
        }
        if (!cursor.atSpace() || this.level < this.minLevel || this.level > this.maxLevel) {
            return null;
        }
        cursor.skipSpaces();
        var start = cursor.pos;
        cursor.skipToEndOfBlock().skipBlankLines();
        return cursor.subRegion(start, cursor.pos);
    };
    HeadingRule.prototype.parseSubRegion = function (region) {
        var children = this.parseInlineContent(region);
        return new nodes_1.HtmlElementNode(region, children, 'h' + this.level, this.selector);
    };
    return HeadingRule;
}(block_1.BlockRule));
exports.HeadingRule = HeadingRule;
//# sourceMappingURL=heading.js.map