"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../../core");
var block_1 = require("./block");
var nodes_1 = require("../../nodes");
var CHAR_MINUS = core_1.constants.CHAR_MINUS;
var HrRule = (function (_super) {
    __extends(HrRule, _super);
    function HrRule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HrRule.prototype.scanBlock = function (cursor) {
        if (!cursor.atSeq(CHAR_MINUS, CHAR_MINUS, CHAR_MINUS)) {
            return null;
        }
        var start = cursor.pos;
        cursor.skipToEndOfBlock().skipBlankLines();
        return cursor.subRegion(start, cursor.pos);
    };
    HrRule.prototype.parseSubRegion = function (region) {
        var cursor = new core_1.Cursor(region);
        while (cursor.atCode(CHAR_MINUS)) {
            cursor.skip();
        }
        cursor.skipBlankLines();
        if (cursor.hasCurrent()) {
            return null;
        }
        return new nodes_1.HtmlElementNode(region, [], 'hr', this.selector, false, true);
    };
    return HrRule;
}(block_1.BlockRule));
exports.HrRule = HrRule;
//# sourceMappingURL=hr.js.map