"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var block_1 = require("./block");
var nodes_1 = require("../../nodes");
var html_1 = require("../../util/html");
var HtmlBlockRule = (function (_super) {
    __extends(HtmlBlockRule, _super);
    function HtmlBlockRule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HtmlBlockRule.prototype.scanBlock = function (cursor) {
        var start = cursor.pos;
        var openingTag = html_1.matchHtmlTag(cursor);
        if (!openingTag) {
            return null;
        }
        if (openingTag.type !== html_1.HtmlTagType.OPENING) {
            return null;
        }
        while (cursor.hasCurrent()) {
            cursor
                .skipToEol()
                .skipNewLine()
                .skipSpaces(this.indent);
            var closingTag = html_1.matchHtmlTag(cursor);
            if (!closingTag) {
                continue;
            }
            if (closingTag.type !== html_1.HtmlTagType.CLOSING ||
                closingTag.tagName !== openingTag.tagName) {
                continue;
            }
            cursor.skipSpaces();
            if (cursor.atBlankLine()) {
                cursor.skipNewLine();
                if (cursor.atBlankLine()) {
                    return cursor.subRegion(start, cursor.pos);
                }
            }
        }
        return null;
    };
    HtmlBlockRule.prototype.parseSubRegion = function (region) {
        return new nodes_1.TextNode(region);
    };
    HtmlBlockRule.prototype.parseSelectorAt = function () {
        return null;
    };
    return HtmlBlockRule;
}(block_1.BlockRule));
exports.HtmlBlockRule = HtmlBlockRule;
//# sourceMappingURL=html-block.js.map