"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../../core");
var block_1 = require("./block");
var nodes_1 = require("../../nodes");
var CHAR_TILDE = core_1.constants.CHAR_TILDE;
var IndentedBlock = (function (_super) {
    __extends(IndentedBlock, _super);
    function IndentedBlock() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.tagName = '';
        return _this;
    }
    IndentedBlock.prototype.scanBlock = function (cursor) {
        if (!cursor.atCode(CHAR_TILDE)) {
            return null;
        }
        cursor.skip();
        this.tagName = this.readTagName(cursor);
        if (!this.tagName) {
            return null;
        }
        while (cursor.atSpace()) {
            cursor.skip();
        }
        var contentStart = cursor.pos;
        while (cursor.hasCurrent()) {
            cursor.skipToEndOfBlock().skipBlankLines();
            if (!cursor.atSpaces(this.indent + 2)) {
                break;
            }
        }
        return cursor.subRegion(contentStart, cursor.pos);
    };
    IndentedBlock.prototype.readTagName = function (cursor) {
        var start = cursor.pos;
        while (cursor.hasCurrent() && cursor.atIdentifier()) {
            cursor.skip();
        }
        return cursor.subRegion(start, cursor.pos).toString();
    };
    IndentedBlock.prototype.parseSubRegion = function (region) {
        var cursor = new core_1.Cursor(region);
        cursor.skipTainted();
        var isBlock = cursor.atNewLine();
        var children = isBlock ? this.parseBlockContent(region) : this.parseInlineContent(region);
        return new nodes_1.HtmlElementNode(region, children, this.tagName, this.selector);
    };
    return IndentedBlock;
}(block_1.BlockRule));
exports.IndentedBlock = IndentedBlock;
//# sourceMappingURL=indented-block.js.map