"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../../core");
var text_1 = require("../../nodes/text");
var DEFAULT_CONTROL_CHARACTERS = core_1.constants.DEFAULT_CONTROL_CHARACTERS, CHAR_BACKSLASH = core_1.constants.CHAR_BACKSLASH;
var BackslashEscapeRule = (function (_super) {
    __extends(BackslashEscapeRule, _super);
    function BackslashEscapeRule(ctx, options) {
        if (options === void 0) { options = {}; }
        var _a;
        var _this = _super.call(this, ctx) || this;
        _this.controlCharacters = (_a = options.controlCharacters, (_a !== null && _a !== void 0 ? _a : DEFAULT_CONTROL_CHARACTERS));
        return _this;
    }
    BackslashEscapeRule.prototype.parseAt = function (cursor) {
        if (cursor.atCode(CHAR_BACKSLASH)) {
            var next = cursor.peekCode(1);
            if (this.isControlChar(next)) {
                cursor.skip();
                return new text_1.TextNode(cursor.readForward(1));
            }
        }
        return null;
    };
    BackslashEscapeRule.prototype.isControlChar = function (code) {
        return this.controlCharacters.indexOf(code) > -1;
    };
    return BackslashEscapeRule;
}(core_1.Rule));
exports.BackslashEscapeRule = BackslashEscapeRule;
//# sourceMappingURL=backslash-escape.js.map