"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../../core");
var plain_text_1 = require("./plain-text");
var html_entity_1 = require("./html-entity");
var verbatim_1 = require("./verbatim");
var bracket_1 = require("../block/bracket");
var CHAR_LT = core_1.constants.CHAR_LT, CHAR_GT = core_1.constants.CHAR_GT, CHAR_AMP = core_1.constants.CHAR_AMP;
var FormulaRule = (function (_super) {
    __extends(FormulaRule, _super);
    function FormulaRule(ctx, options) {
        var _this = _super.call(this, ctx) || this;
        _this.marker = options.marker;
        _this.parser = new core_1.Parser(ctx, [
            new plain_text_1.PlainTextRule(ctx, {
                controlCharacters: [
                    CHAR_AMP,
                    CHAR_LT,
                    CHAR_GT,
                ]
            }),
            new html_entity_1.HtmlEntityRule(ctx),
            new verbatim_1.VerbatimRule(ctx),
        ]);
        return _this;
    }
    Object.defineProperty(FormulaRule.prototype, "openMarker", {
        get: function () {
            return this.marker;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FormulaRule.prototype, "closeMarker", {
        get: function () {
            return this.marker;
        },
        enumerable: true,
        configurable: true
    });
    FormulaRule.prototype.parseSubRegion = function (region) {
        var root = this.parser.parse(region);
        return new FormulaNode(region, root.children, this.marker);
    };
    return FormulaRule;
}(bracket_1.BracketRule));
exports.FormulaRule = FormulaRule;
var FormulaNode = (function (_super) {
    __extends(FormulaNode, _super);
    function FormulaNode(region, children, marker) {
        var _this = _super.call(this, region, children) || this;
        _this.marker = marker;
        return _this;
    }
    FormulaNode.prototype.render = function (ctx) {
        return "" + this.marker + ctx.renderChildren(this) + this.marker;
    };
    return FormulaNode;
}(core_1.Node));
exports.FormulaNode = FormulaNode;
//# sourceMappingURL=formula.js.map