"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../../core");
var text_1 = require("../../nodes/text");
var CHAR_LT = core_1.constants.CHAR_LT;
var HtmlCommentRule = (function (_super) {
    __extends(HtmlCommentRule, _super);
    function HtmlCommentRule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HtmlCommentRule.prototype.parseAt = function (cursor) {
        if (!cursor.atCode(CHAR_LT)) {
            return null;
        }
        if (!cursor.at('<!--')) {
            return null;
        }
        var start = cursor.pos;
        while (cursor.hasCurrent()) {
            if (cursor.at('-->')) {
                cursor.skip(3);
                return new text_1.TextNode(cursor.subRegion(start, cursor.pos));
            }
            cursor.skip();
        }
        return null;
    };
    return HtmlCommentRule;
}(core_1.Rule));
exports.HtmlCommentRule = HtmlCommentRule;
//# sourceMappingURL=html-comment.js.map