"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../../core");
var text_1 = require("../../nodes/text");
var nodes_1 = require("../../nodes");
var latinLetters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
var decimalDigits = '0123456789';
var hexDigits = '0123456789abcdefABCDEF';
var CHAR_AMP = core_1.constants.CHAR_AMP, CHAR_LT = core_1.constants.CHAR_LT, CHAR_GT = core_1.constants.CHAR_GT;
var HtmlEntityRule = (function (_super) {
    __extends(HtmlEntityRule, _super);
    function HtmlEntityRule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HtmlEntityRule.prototype.parseAt = function (cursor) {
        return this.tryAmp(cursor) ||
            this.tryLt(cursor) ||
            this.tryGt(cursor);
    };
    HtmlEntityRule.prototype.tryAmp = function (cursor) {
        if (!cursor.atCode(CHAR_AMP)) {
            return null;
        }
        var end = this.matchEntityReference(cursor.clone());
        if (end == null) {
            return new nodes_1.LiteralNode(cursor.readForward(1), '&amp;');
        }
        return new text_1.TextNode(cursor.readUntil(end));
    };
    HtmlEntityRule.prototype.matchEntityReference = function (cursor) {
        cursor.skip();
        var allowedChars = latinLetters;
        if (cursor.at('#x') || cursor.at('#X')) {
            allowedChars = hexDigits;
            cursor.skip(2);
        }
        else if (cursor.at('#')) {
            allowedChars = decimalDigits;
            cursor.skip(1);
        }
        if (cursor.at(';')) {
            return null;
        }
        while (cursor.hasCurrent()) {
            var c = cursor.current();
            if (c === ';') {
                cursor.skip();
                return cursor.pos;
            }
            else if (allowedChars.indexOf(c) > -1) {
                cursor.skip();
            }
            else {
                return null;
            }
        }
        return null;
    };
    HtmlEntityRule.prototype.tryLt = function (cursor) {
        if (!cursor.atCode(CHAR_LT)) {
            return null;
        }
        return new nodes_1.LiteralNode(cursor.readForward(1), '&lt;');
    };
    HtmlEntityRule.prototype.tryGt = function (cursor) {
        if (!cursor.atCode(CHAR_GT)) {
            return null;
        }
        return new nodes_1.LiteralNode(cursor.readForward(1), '&gt;');
    };
    return HtmlEntityRule;
}(core_1.Rule));
exports.HtmlEntityRule = HtmlEntityRule;
//# sourceMappingURL=html-entity.js.map