import { Rule, Cursor, Node, Region } from '../../core';
import { MediaDef } from '../../util/media';
import { ContextWithMedia } from '../../context';
export declare class LinkRule extends Rule {
    readonly ctx: ContextWithMedia;
    constructor(ctx: ContextWithMedia);
    protected parseAt(cursor: Cursor): Node | null;
    protected findClosingMarker(cursor: Cursor): number | null;
    protected tryInlineLink(children: Node[], cursor: Cursor, regionStart: number): Node | null;
    protected tryRefLink(children: Node[], cursor: Cursor, regionStart: number): Node | null;
}
export declare class HeadlessLinkRule extends Rule {
    readonly ctx: ContextWithMedia;
    constructor(ctx: ContextWithMedia);
    protected parseAt(cursor: Cursor): Node | null;
}
export declare class LinkNode extends Node {
    id: string;
    isHeadless: boolean;
    constructor(region: Region, children: Node[], id: string, isHeadless?: boolean);
    resolveMedia(ctx: ContextWithMedia): MediaDef | null;
    renderContent(ctx: ContextWithMedia): string;
    render(ctx: ContextWithMedia): string;
}
