import { Rule, Cursor, Node, Region } from '../../core';
import { MediaDef } from '../../util/media';
import { ContextWithMedia } from '../../context';
export declare class MediaRule extends Rule {
    readonly ctx: ContextWithMedia;
    constructor(ctx: ContextWithMedia);
    protected parseAt(cursor: Cursor): Node | null;
    protected tryInlineImg(cursor: Cursor, text: string, regionStart: number): Node | null;
    protected tryRefImg(cursor: Cursor, text: string, regionStart: number): Node | null;
}
export declare class HeadlessMediaRule extends Rule {
    readonly ctx: ContextWithMedia;
    constructor(ctx: ContextWithMedia);
    protected parseAt(cursor: Cursor): Node | null;
}
export declare class MediaNode extends Node {
    id: string;
    text: string;
    constructor(region: Region, id: string, text?: string);
    resolveMedia(ctx: ContextWithMedia): MediaDef | null;
    render(ctx: ContextWithMedia): string;
}
