"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var text_1 = require("../../nodes/text");
var core_1 = require("../../core");
var DEFAULT_CONTROL_CHARACTERS = core_1.constants.DEFAULT_CONTROL_CHARACTERS, RANGE_DIGIT_START = core_1.constants.RANGE_DIGIT_START, RANGE_DIGIT_END = core_1.constants.RANGE_DIGIT_END, RANGE_LATIN_LOWER_START = core_1.constants.RANGE_LATIN_LOWER_START, RANGE_LATIN_LOWER_END = core_1.constants.RANGE_LATIN_LOWER_END, RANGE_LATIN_UPPER_START = core_1.constants.RANGE_LATIN_UPPER_START, RANGE_LATIN_UPPER_END = core_1.constants.RANGE_LATIN_UPPER_END, CHAR_SPACE = core_1.constants.CHAR_SPACE, CHAR_LF = core_1.constants.CHAR_LF, CHAR_CR = core_1.constants.CHAR_CR;
var PlainTextRule = (function (_super) {
    __extends(PlainTextRule, _super);
    function PlainTextRule(ctx, options) {
        if (options === void 0) { options = {}; }
        var _a;
        var _this = _super.call(this, ctx) || this;
        _this.controlCharacters = (_a = options.controlCharacters, (_a !== null && _a !== void 0 ? _a : DEFAULT_CONTROL_CHARACTERS));
        return _this;
    }
    PlainTextRule.prototype.parseAt = function (cursor) {
        var start = cursor.pos;
        while (cursor.hasCurrent()) {
            var code = cursor.currentCode();
            if (code >= RANGE_LATIN_LOWER_START && code <= RANGE_LATIN_LOWER_END ||
                code >= RANGE_LATIN_UPPER_START && code <= RANGE_LATIN_UPPER_END ||
                code >= RANGE_DIGIT_START && code <= RANGE_DIGIT_END ||
                code === CHAR_SPACE || code === CHAR_LF || code === CHAR_CR) {
                cursor.skip();
                continue;
            }
            if (this.controlCharacters.indexOf(code) > -1) {
                break;
            }
            cursor.skip();
        }
        if (cursor.pos === start) {
            return null;
        }
        return new text_1.TextNode(cursor.subRegion(start, cursor.pos));
    };
    return PlainTextRule;
}(core_1.Rule));
exports.PlainTextRule = PlainTextRule;
//# sourceMappingURL=plain-text.js.map