"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../../core");
var nodes_1 = require("../../nodes");
var CHAR_QUOTE_SINGLE = core_1.constants.CHAR_QUOTE_SINGLE, CHAR_QUOTE_DOUBLE = core_1.constants.CHAR_QUOTE_DOUBLE;
var TypographicsRule = (function (_super) {
    __extends(TypographicsRule, _super);
    function TypographicsRule(ctx, options) {
        var _this = _super.call(this, ctx) || this;
        _this.options = options;
        return _this;
    }
    TypographicsRule.prototype.parseAt = function (cursor) {
        var code = cursor.currentCode();
        switch (code) {
            case CHAR_QUOTE_SINGLE: {
                var quoteChar = this.isLeftQuote(cursor) ?
                    this.options.leftSingleQuote : this.options.rightSingleQuote;
                var region = cursor.readForward(1);
                return new nodes_1.LiteralNode(region, quoteChar);
            }
            case CHAR_QUOTE_DOUBLE: {
                var quoteChar = this.isLeftQuote(cursor) ?
                    this.options.leftDoubleQuote : this.options.rightDoubleQuote;
                var region = cursor.readForward(1);
                return new nodes_1.LiteralNode(region, quoteChar);
            }
        }
        return null;
    };
    TypographicsRule.prototype.isLeftQuote = function (cursor) {
        var whitespaceBefore = cursor.pos === 0 ||
            cursor.clone().skip(-1).atWhitespace();
        var whitespaceAfter = cursor.clone().skip(1).atWhitespace();
        return whitespaceBefore && !whitespaceAfter;
    };
    return TypographicsRule;
}(core_1.Rule));
exports.TypographicsRule = TypographicsRule;
//# sourceMappingURL=typographics.js.map