"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../core");
var CHAR_BACKSLASH = core_1.constants.CHAR_BACKSLASH, CHAR_PIPE = core_1.constants.CHAR_PIPE, CHAR_COMMA = core_1.constants.CHAR_COMMA;
var HREF_AUX_DELIMITERS = [
    0x58,
    0x78,
    CHAR_COMMA
];
function parseHref(str) {
    var src = '';
    var width = '';
    var height = '';
    var cursor = new core_1.Cursor(str);
    while (cursor.hasCurrent()) {
        if (cursor.atCode(CHAR_BACKSLASH)) {
            src += cursor.peek(1);
            cursor.skip(2);
            continue;
        }
        if (cursor.atCode(CHAR_PIPE)) {
            cursor.skip();
            break;
        }
        src += cursor.current();
        cursor.skip();
    }
    while (cursor.hasCurrent() && cursor.atDigit()) {
        width += cursor.current();
        cursor.skip();
    }
    if (HREF_AUX_DELIMITERS.some(function (_) { return cursor.atCode(_); })) {
        cursor.skip();
        while (cursor.hasCurrent() && cursor.atDigit()) {
            height += cursor.current();
            cursor.skip();
        }
    }
    return {
        src: src,
        width: width ? Number(width) : undefined,
        height: height ? Number(height) : undefined,
    };
}
exports.parseHref = parseHref;
//# sourceMappingURL=media.js.map